/*  thread-beispiel.c (Praktikum, Arbeitsblatt 2)

    Vorlesung Betriebssysteme
    Hans-Georg Eer, Hochschule Mnchen
    hans-georg.esser@hm.edu
*/

#include <pthread.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>  /* printf() */

void *thread_function1(void *arg) {
  int i;
  for ( i=0; i<10; i++ ) {
    printf("Thread 1 sagt Hi!\n");
    sleep(1);
  }
  return NULL;
}
void *thread_function2(void *arg) {
  int i;
  for ( i=0; i<10; i++ ) {
    printf("Thread 2 sagt Hallo!\n");
    sleep(1);
  }
  return NULL;
}
int main(void) {
  pthread_t mythread1;
  pthread_t mythread2;
  if ( pthread_create( &mythread1, NULL,
       thread_function1, NULL) ) {
    printf("Fehler bei Thread-Erzeugung.");
    abort();
  }
  sleep(5);
  if ( pthread_create( &mythread2, NULL,
       thread_function2, NULL) ) {
    printf("Fehler bei Thread-Erzeugung .");
    abort();
  }
  sleep(5);
  printf("bin noch hier...\n");
  if ( pthread_join ( mythread1, NULL ) ) {
    printf("Fehler beim Join.");
    abort();
  }
  printf("Thread 1 ist weg\n");
  if ( pthread_join ( mythread2, NULL ) ) {
    printf("Fehler beim Join.");
    abort();
  }
  printf("Thread 2 ist weg\n");
  exit(0);
}
